'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAce = require('react-ace');

var _reactAce2 = _interopRequireDefault(_reactAce);

var _Preview = require('./Preview.css');

var _Preview2 = _interopRequireDefault(_Preview);

require('brace/mode/batchfile');

require('brace/mode/css');

require('brace/mode/html');

require('brace/mode/javascript');

require('brace/mode/json');

require('brace/mode/jsx');

require('brace/mode/markdown');

require('brace/mode/php');

require('brace/mode/sh');

require('brace/mode/text');

require('brace/theme/github');

require('brace/theme/monokai');

require('brace/theme/terminal');

require('brace/theme/tomorrow');

var _config = require('./config');

var _createHighlightMarkers = require('./createHighlightMarkers');

var _createHighlightMarkers2 = _interopRequireDefault(_createHighlightMarkers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getLanguageTitle(value) {
  var found = _config.SUPPORTED_LANGUAGES.find(function (lang) {
    return lang.value === value;
  });
  return found ? found.title : null;
}

var CodePreview = function (_PureComponent) {
  _inherits(CodePreview, _PureComponent);

  function CodePreview() {
    _classCallCheck(this, CodePreview);

    return _possibleConstructorReturn(this, (CodePreview.__proto__ || Object.getPrototypeOf(CodePreview)).apply(this, arguments));
  }

  _createClass(CodePreview, [{
    key: 'render',
    value: function render() {
      var layout = this.props.layout;

      return layout === 'block' ? this.renderBlockPreview() : this.renderDefaultPreview();
    }
  }, {
    key: 'renderDefaultPreview',
    value: function renderDefaultPreview() {
      var value = this.props.value;

      return _react2.default.createElement(
        'div',
        { className: _Preview2.default.defaultPreviewContainer },
        _react2.default.createElement(
          'div',
          null,
          value && value.language ? getLanguageTitle(value.language) : 'Unknown language'
        )
      );
    }
  }, {
    key: 'renderBlockPreview',
    value: function renderBlockPreview() {
      var _props = this.props,
          value = _props.value,
          type = _props.type;

      var fixedLanguage = (0, _get3.default)(type, 'options.language');
      return _react2.default.createElement(
        'div',
        { className: _Preview2.default.root },
        _react2.default.createElement(
          'h3',
          null,
          value && getLanguageTitle(value.language)
        ),
        _react2.default.createElement(
          'div',
          { className: _Preview2.default.aceWrapper },
          _react2.default.createElement(_reactAce2.default, {
            mode: value && value.language || fixedLanguage || 'text',
            theme: 'tomorrow',
            width: '100%',
            height: null,
            maxLines: 200,
            readOnly: true,
            wrapEnabled: true,
            showPrintMargin: false,
            highlightActiveLine: false,
            cursorStart: -1,
            value: value && value.code || '',
            markers: value && value.highlightedLines ? (0, _createHighlightMarkers2.default)(value.highlightedLines) : null,
            onLoad: this.handleEditorLoad,
            tabSize: 2,
            showGutter: false,
            setOptions: _config.ACE_SET_OPTIONS,
            editorProps: _config.ACE_EDITOR_PROPS
          })
        )
      );
    }
  }]);

  return CodePreview;
}(_react.PureComponent);

CodePreview.propTypes = {
  type: _propTypes2.default.object,
  layout: _propTypes2.default.string,
  value: _propTypes2.default.shape({
    _type: _propTypes2.default.string,
    code: _propTypes2.default.string,
    language: _propTypes2.default.string,
    highlightedLines: _propTypes2.default.array
  })
};
exports.default = CodePreview;